<?php

/*
---

license: GNU GPL (http://www.gnu.org/licenses/gpl.html)
copyright: Philipp Sengelmann (http://www.dc-development.de)
authors: Philipp Sengelmann (http://www.dc-development.de)

...
*/

class siteObject extends project{
	
	public $project = 1;
	public $lang = 'de';
	public $masterId = 0;
	public $mapId = 1;
	public $rootObject = 0;
	public $objectTable = 'pp_pageobject_lookup';
	public $typeTable = 'pp_pageobjects';
	public $propTable = 'pp_properties_lookup';
	public $projectSettings = array();
	public $siteMap = array();
	public $contentArray = array();
	public $startArray = array();
	public $sorted = false;
	public $inLoop = false;
	

	public function setLanguage($lang){
		$this -> lang = $lang;
	}
	public function setMasterId($id){
		$this -> masterId = $id;
	}
	public function setSiteMap($id){
		$this -> mapId = $id;
	}
	public function setRootObject($id){
		$this -> rootObject = $id;
	}
	public function setObjectTable($objectTable){
		$this -> objectTable = $objectTable;
	}
	public function setSorted($bool){
		$this -> sorted = $bool;
	}
	public function setTypeTable($typeTable){
		$this -> typeTable = $typeTable;	
	}
	public function emptyContentArray(){
		$this -> contentArray = array();
	}
	
	public function getSiteMap(){
		$this -> emptyContentArray();// empty content array
		$this -> setObjectTable('pp_sitemap_lookup');
		$this -> rootObject = $this -> mapId;
		$this -> setSorted(true);
		$this -> getObjectArray();
		return 	$this -> contentArray;
	}
	
	public function getMifTreeArray(){
		$this -> emptyContentArray();// empty content array
		$this -> setSorted(true);
		$this -> getObjectArray();
		$menuItem =	$this -> contentArray;
		$menuData = array(
				'items' => array(),
				'parents' => array()
		);
		for($i = 0; $i < count($menuItem); $i++) {
			$menuData['items'][$menuItem[$i]['id']] = $menuItem[$i];
			$menuData['parents'][$menuItem[$i]['childOf']][] = $menuItem[$i]['id'];
		}	      
		$contentJson = json_encode($menuData);
		return $menuData;
	}


	public function getObjectArray(){

		$rootObject = $this -> rootObject;
		$objectTable = $this -> objectTable;
		$orderBy = "";
		
		if($this -> sorted=='true')$orderBy = "ORDER BY order_id";

		$contentQuery = "SELECT * FROM $objectTable WHERE co = $rootObject $orderBy"; 
		$get_contentObjects = mysql_query($contentQuery);	
		while($temp = mysql_fetch_array($get_contentObjects)){
			$contentArray = $this -> contentArray;
			$isLeaf = $this -> isLeaf($temp['mid'],$objectTable);
			$this -> setTypeTable('pp_pageobjects');
			$typeName = $this -> getTypeName($temp['oid']);
			$this -> setTypeTable('pp_properties');
			$elementProps = $this -> getProps($temp['mid']);

			$text = $this -> getTextContent($temp['mid']);		
			array_push($contentArray, array(
			'id' => $temp['mid'],
			'childOf' => $temp['co'],
			'type' => $typeName,
			'isLeaf' => $isLeaf,
			'inlineProps' => $elementProps,
			'name' =>  $temp[5],
			'title' =>  $temp[4],
			'order_id' => $temp[4],
			'text' =>  str_replace('&#039;', '\'', $text)
			));
/*
			foreach($elementProps as $elementProp){
				array_push($contentArray, array(
					'id' => $elementProp['db_id'],
					'childOf' => $temp['mid'],
					'type' => 'attribute',
					'title' =>  $elementProp['value'],
					'order_id' => $temp[4],
					'isLeaf' => true,
					'name' => $elementProp['name'],
					'text' => $elementProp['value']
				));
			} 
			*/
			$this -> contentArray = $contentArray;
			if($isLeaf!=true){	
				$this -> setTypeTable('pp_pageobjects');
				$this -> setRootObject($temp['mid']);
				$this -> getObjectArray();
			}		
		}
	}
	
	// RETURNS AN ARRAY OF NAME-VALUE PAIRS FOR INLINE PROPS
	public function getProps($id){
		$inlineProps =  array();
		$table = $this -> propTable;
		$get_prop_values = mysql_query("SELECT * FROM $table WHERE co = $id");
		while($get_values = mysql_fetch_array($get_prop_values)){
			$name = $this -> getTypeName($get_values['oid']);
			array_push($inlineProps, array(
			'db_id' => $get_values['mid'],
			'childOf' => $get_values['mid'],
			'name' =>  $name,
			'value' => $get_values['value']
			));
		}
		return $inlineProps;
	}
	// CHECK IF OBJECT HAS CHILDREN
	public function isLeaf($id,$table){
		$gotNodes = mysql_query("SELECT COUNT(*) FROM $table WHERE co = $id");
		$child=mysql_fetch_array($gotNodes);
		if($child[0] == 0){
			return true;
		}else{
			return false;
		}
	}
	// GET OBJECT TEXT CONTENT BY ID AND CURRENT LANGUAGE
	public function getTextContent($id){
		$lang = $this-> lang;
		$d = mysql_query("SELECT $lang FROM pp_text WHERE id = $id");
		if($d){
			$tempd = mysql_fetch_array($d);
			return $tempd[0];
		}
	}
	// RETURNS AN ARRAY OF ELEMENT MIDs FROM THE GIVEN ONE UP TO ROOT ELEMENT (ONE TABLE ONLY, YET)
	public function getActiveElement($id){
		$objectTable = $this -> objectTable;
		$root = false;
		$a = array();
		while($root!=true){
			$query_ActiveNavParts = mysql_query("SELECT * FROM $objectTable WHERE mid = $id");
			$temp = mysql_fetch_array($query_ActiveNavParts);
			if($temp){
				$id = $temp['co'];
				array_push($a, $temp['mid']);
			}else{
				$root = true;
			}
		}
		$breadcrumb = array_reverse($a);
		return $breadcrumb;
	}
	// RETURNS NAME (TEXT) OF TYPE OF OBJECT OR PROPERTY BY TABLE_ID
	public function getTypeName($id){
		$table = $this -> typeTable;
		$d = mysql_query($query = "SELECT name FROM $table WHERE mid = $id");
		$tempd = mysql_fetch_array($d);
		return $tempd['name'];
	}
	
}

?>