/**
 *
 * In this file we setup our Columns and Panels
 * At the bottom of Core.js you can setup lazy loading for your own plugins.
 *
 */

initializeColumns = function() {

	/**
	 * Build MochaUI columns
	 */

	new MUI.Column({
		id : 'sideColumn1',
		placement : 'left',
		width : 336,
		resizeLimit : [50, 340]
	});
	new MUI.Column({
		id : 'mainColumn',
		placement : 'main',
		resizeLimit : [100, 1200]
	});

	/**
	 * Add MochaUI panels to first side column
	 */

	// TREEVIEW PANEL
	new MUI.Panel({
		id : 'treeView',
		contentURL : 'pages/mif-tree-project.html',
		column : 'sideColumn1',
		tabsURL : 'pages/panel-tabs.html',
		require : {
			css : [MUI.path.plugins + 'mif-tree/css/mif-tree.css'],
			js : [MUI.path.plugins + 'mif-tree/mif.tree-v1.2.6.4.js']
		},
		onContentLoaded : function(a) {
			//MUI.trace('MUI.PANEL "Treeview" <- reloaded at appstate = '+ MUI.appState);
			
			

			MUI.updateInterfaces(MUI.focusedObjectId, 'reloadedTree');
		}
	});
	// ELEMENTS PANEL
	new MUI.Panel({
		id : 'objectCollection',
		title : 'Elements',
		contentURL : MUI.appPath + '/admin_data.php?getPageObjects=yesplease',
		column : 'sideColumn1',
		height : 280,
		onContentLoaded : function() {
			$$('.objectButtons .submit').setStyle('display', 'none');
			$$('input.submitElement').addEvent('click', function(a) {
				$('elements')['edit_mode'].value = MUI.appState;
				$('elements')['focusedObject'].value = MUI.focusedObjectId;
				$('elements')['pnewObject'].value = $(this).id;
			});
			$('elements').addEvent('submit', function(e) {
				e.stop();
				$('spinner').show();
				if($('postContent') && MUI.options.standardEffects == true) {
					$('postContent').setStyle('opacity', 0);
				}
				MUI.createObject(this)
			});
		}
	});
	// PROPERTIES PANEL
	new MUI.Panel({
		id : 'propertiesForm',
		title : 'Object Props',
		contentURL : 'pages/ajax.form.html',
		column : 'sideColumn1',
		height : 180,
		onContentLoaded : function() {
			$('myForm').addEvent('submit', function(e) {
				e.stop();
				MUI.saveAttributeList(this);
			});
			$$('a.deleteAttribute').addEvent('click', function(e) {
				e.stop();
				MUI.deleteAttribute(this);
			});
		}
	});
	
	/**
	 * Add MochaUI panels to main column
	 */
	
	// MAIN PROJECT PANEL
	new MUI.Panel({
		id : 'mainPanel',
		title : 'Select a project',
		loadMethod : 'iframe',
		column : 'mainColumn',
		contentURL : 'pages/poppy_start.html',
		onContentLoaded : function(a) {	
			MUI.mainContentFrame = MUI.getFrameByName('mainPanel_iframe');
			$('mainPanel_title').set('text', MUI.mainContentFrame.pp_projectName);
			MUI.setPage(MUI.mainContentFrame.pp_projectId, MUI.mainContentFrame.pp_masterId, MUI.mainContentFrame.pp_pageId, MUI.mainContentFrame.pp_pageLang, MUI.mainContentFrame.pp_mapId, MUI.mainContentFrame.pp_projectName);	
			MUI.mainContentFrame.$$('a.objectHandle').addEvent('click', function(e) {
				e.stop();
				var myID = this.id.split('_')[1];
				parent.MochaUI.updateInterfaces(myID, 'focus');
			});

			if(!MUI.mainContentFrame.$('contextmenu')) {// Inject the contextmenu ul in iFrame page
				MUI.injectInIframe = new Element('ul', {
					'id' : 'contextmenu'
				}).inject(MUI.mainContentFrame.$$('body')[0]);
				MUI.mainContentFrame.$('contextmenu').set('html', '<li><a href="#edit" class="edit">Edit</a></li><li class="separator"><a href="#cut" class="cut">Cut</a></li><li><a href="#copy" class="copy">Copy</a></li><li><a href="#paste" class="paste">Paste</a></li><li><a href="#delete" class="delete">Delete</a></li><li class="separator"><a href="#quit" class="quit">Quit</a></li>');
				MUI.mainContentFrame.context_menu_init();// init contextmenu ul in iFrame page
			}
			MUI.mainContentFrame.$$('div.objectHandle').addClass('hidden');
			MUI.mainContentFrame.$$('a.navLink').addEvent('click', function(e) {
				var newFocus = this.id.split('_')[1]; 
				parent.MUI.setFocusedObjectId(newFocus);
			});
			state = MUI.appState;
			if(state == 'editMaster') {
				MUI.mainContentFrame.$$('div.objectHandle.master').toggleClass('hidden');
			}
			if(state == 'editContent') {
				MUI.mainContentFrame.$$('div.objectHandle.content').toggleClass('hidden');
			}
			if(MUI.toggles['handles_hide'] == 1) {
				MUI.toggleHandlesVisuals(1, 'handles_hide');
			}
			if(MUI.toggles['handles_dom'] == 1) {
				MUI.toggleHandlesVisuals(1, 'handles_dom');
			}
			MUI.doSomeInIframe(MUI.focusedObjectId);	
		}
	});
	// TEXT EDITOR
	new MUI.Panel({
		id : 'textForm',
		addClass : 'textForm',
		height : 180,
		title : 'Object Text',
		contentURL : 'pages/lipsum.html',
		column : 'mainColumn',
		onContentLoaded : function() {
			$('objectTextForm').addEvent('submit', function(e) {
				e.stop();
				$('spinner').show();
				if($('postContent') && MUI.options.standardEffects == true) {
					$('postContent').setStyle('opacity', 0);
				}
				MUI.editObjectText(this);
			});
		}
	});
	MUI.myChain.callChain();
};
