/*
 *
 * My MUI.Functions
 * 
 *
 */

// Initialize MochaUI all MUI.Functions when DOM is ready
window.addEvent('load', function(){ // using load instead of DOM ready for IE8 just use initializeFunctions for outlines in eclipse 
	initializeFunctions();
}); 
var initializeFunctions = function() {	
	
	MUI.setFocusedObjectId = function(id) {
		MUI.focusedObjectId = id;
	};

	MUI.setAppState = function(state) {
		// Set appState
		MUI.appState = state;
		//Apply Element Filters for appState
		if(state == 'editSitemap') {
			MUI.elementFilter = ['navElement'];
		}
		if(state == 'editMaster') {
			MUI.elementFilter = ['XML Declaration', 'DOCTYPE', 'modul', 'a', 'abbr', 'acronym', 'address', 'area', 'b', 'base', 'bdo', 'big', 'blockquote', 'body', 'br', 'caption', 'cite', 'code', 'col', 'colgroup', 'dd', 'del', 'dfn', 'div', 'dl', 'dt', 'em', 'fieldset', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'hr', 'html', 'i', 'img', 'input', 'ins', 'kbd', 'label', 'legend', 'li', 'link', 'map', 'meta', 'noscript', 'object', 'ol', 'optgroup', 'option', 'p', 'param', 'pre', 'q', 'rb', 'rbc', 'rp', 'rt', 'rtc', 'ruby', 'samp', 'script', 'select', 'small', 'span', 'strong', 'style', 'sub', 'sup', 'table', 'tbody', 'td', 'textarea', 'tfoot', 'th', 'thead', 'title', 'tr', 'tt', 'ul', 'var'];
		}
		if(state == 'editContent') {
			MUI.elementFilter = ['a', 'abbr', 'acronym', 'address', 'area', 'b', 'base', 'bdo', 'big', 'blockquote', 'br', 'caption', 'cite', 'code', 'col', 'colgroup', 'dd', 'del', 'dfn', 'div', 'dl', 'dt', 'em', 'fieldset', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'hr', 'i', 'img', 'input', 'ins', 'kbd', 'label', 'legend', 'li', 'link', 'map', 'noscript', 'object', 'ol', 'optgroup', 'option', 'p', 'param', 'pre', 'q', 'rb', 'rbc', 'rp', 'rt', 'rtc', 'ruby', 'samp', 'script', 'select', 'small', 'span', 'strong', 'style', 'sub', 'sup', 'table', 'tbody', 'td', 'textarea', 'tfoot', 'th', 'thead', 'title', 'tr', 'tt', 'ul', 'var'];
		}
		if(state == 'editCss') {
			MUI.elementFilter = ['cssClass'];
		}
		//CSS hiding all elements
		$$('.objectButtons .submit').setStyle('display', 'none');
		//CSS show all filtered elements
		if(MUI.projectId) {
			Array.each(MUI.elementFilter, function(name, index) {
				$$('.objectButtons .submitElement.' + name).setStyle('display', 'inline');
			});
		}
		return true;
	};

	MUI.setMasterId = function(mid) {
		MUI.masterId = mid;
	};

	MUI.setAction = function(mid) {
		MUI.action = mid;
		return true;
	};

	MUI.setPageId = function(mid) {
		MUI.pageId = mid;
	};

	MUI.setPageLang = function(mid) {
		MUI.pageLang = mid;
	};

	MUI.setMapId = function(mid) {
		MUI.mapId = mid;
	};

	MUI.setProjectId = function(mid) {
		MUI.projectId = mid;
	};
	MUI.setProjectName = function(mid) {
		MUI.projectName = mid;
	};

	MUI.toggleHandlesVisuals = function(mySwitch, action) {
		var mFrame = MUI.mainContentFrame;
		if(MUI.appState == 'editMaster') {
			var hType = '.master';
		}
		if(MUI.appState == 'editContent') {
			var hType = '.content';
		}

		var handle = mFrame.$$('div.objectHandle' + hType);
		var allHandles = mFrame.$$('div.objectHandle');

		switch(action) {
			case 'handles_hide':
				if(mySwitch == 1) {//switch on
					handle.removeClass('visible');
					handle.addClass('hidden');
				}
				if(mySwitch == 0) {//switch off
					handle.removeClass('hidden');
				}
				break;
			case 'handles_dom':
				if(mySwitch == 1) {//switch on
					allHandles.addClass('pos_relative');
				}
				if(mySwitch == 0) {//switch off
					allHandles.removeClass('pos_relative');
				}
				break;
		}
	}
	MUI.toggleHandles = function(action) {
		var hasCheck = $(action).getChildren('div.check').length;
		if(hasCheck > 0) {
			$(action).getChildren('div.check').destroy();
			mySwitch = 0;
		} else {
			MUI.toggleHandlesLink = new Element('div', {
				'class' : 'check',
				'id' : 'handles_check'
			}).inject($(action));
			mySwitch = 1;
		}

		MUI.toggles[action] = mySwitch;

		MUI.toggleHandlesVisuals(mySwitch, action);

	}
	if($$('.switchHandles')) {
		$$('.switchHandles').addEvent('click', function(e) {
			new Event(e).stop();
			MUI.toggleHandles(this.id);
		});

	}


	MUI.exportSite = function() {
		MUI.dbCheck = new Request({
			method : 'post',
			url : MUI.appPath + '/export_site.php',
			data : 'projectId=' + MUI.projectId,
			onComplete : function(response) {
				MUI.notification('Exported Site');
			}
		}).send();
	}
	if($('exportSite')) {
		$('exportSite').addEvent('click', function(e) {
			new Event(e).stop();
			MUI.exportSite();
		});
	}
	MUI.saveProject = function() {
		MUI.dbCheck = new Request({
			method : 'post',
			url : MUI.appPath + '/save_project.php',
			data : 'projectId=' + MUI.projectId,
			onComplete : function(response) {
				MUI.notification('Saved project');
				MUI.trace(response);
			}
		}).send();
		

	}
	
	if($('saveProject')) {
		$('saveProject').addEvent('click', function(e) {
			new Event(e).stop();
			MUI.saveProject();
		});
	}

	MUI.trace = function(mytrace) {
		if($('mochaConsole')) {
			MUI.updateContent({
				'element' : $('mochaConsole'),
				'content' : MUI.escapeHTML($('mochaConsole_content').get('html')) + ' \n ------------------------ \n' + mytrace
			});
			$('mochaConsole_contentWrapper').scrollTop = $('mochaConsole_contentWrapper').scrollHeight;
		}
	};

	

	MUI.escapeHTML = function(str) {
		return unescape((str + '')).replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
	}

	MUI.deleteProject = function(mid) {
		request = new Request({
			method : 'post',
			url : MUI.appPath + '/admin_data.php',
			data : 'fname=deleteProject&appState=' + MUI.appState + '&oid=' + MUI.focusedObjectId,
			onComplete : function(response) {
				MochaUI.closeWindow($('projects'));
			}
		}).send();
	};

	/**
	 * Object functions
	 */

	MUI.createObject = function(obj) {
		obj.set('send', {
			method : 'post',
			url : MUI.appPath + '/admin_data.php',
			onComplete : function(response) {

			},
			onSuccess : function() {
				MUI.updateInterfaces(MUI.focusedObjectId, 'createObject');
			}
		});
		obj.send();
	}
	MUI.deleteObject = function(mid) {
		request = new Request({
			method : 'post',
			url : MUI.appPath + '/admin_data.php',
			data : 'fname=deleteObject&appState=' + MUI.appState + '&oid=' + MUI.focusedObjectId,
			onComplete : function(response) {
				MUI.updateInterfaces(MUI.focusedObjectId, 'deleteObject');

			}
		}).send();
		return true;
	};
	MUI.saveAttributeList = function(obj) {
		obj.set('send', {
			method : 'post',
			url : MUI.appPath + '/admin_data.php',
			onComplete : function(response) {
				MUI.updateInterfaces(MUI.focusedObjectId, 'saveAttributeList');
			},
			onSuccess : function(response) {
			}
		});
		obj.send();
	}
	MUI.deleteAttribute = function(obj) {
		var id = obj.id.split('_')[1];
		request = new Request({
			method : 'post',
			url : MUI.appPath + '/admin_data.php',
			data : 'fname=deleteObject&appState=editAttributes&oid=' + id,
			onComplete : function(response) {
				MUI.updateInterfaces(MUI.focusedObjectId, 'deleteAttribute');
			}
		}).send();
		return true;
	}

	MUI.editObjectText = function(obj) {
		obj.set('send', {
			method : 'post',
			url : MUI.appPath + '/admin_data.php?lang=' + MUI.pageLang,
			onComplete : function(response) {
			},
			onSuccess : function() {
				MUI.updateInterfaces(MUI.focusedObjectId, 'editObjectText');
			}
		});
		obj.send();
	}
	MUI.renameObject = function(obj, newName) {
		request = new Request({
			method : 'post',
			url : MUI.appPath + '/admin_data.php',
			data : 'fid=' + MUI.focusedObjectId + '&editName=' + newName,
			onComplete : function(response) {
				MUI.mainContentFrame.location.reload(true);
			}
		}).send();
	}
	MUI.doSomeInIframe = function(uid) {

		if(MUI.mainContentFrame.$$('.pp_el')) {
			MUI.mainContentFrame.$$('.pp_el').removeClass('focused_element');
			MUI.mainContentFrame.$$('.pp_el_' + uid).addClass('focused_element');
		}
	};
	MUI.getFrameByName = function(name) {
		for( i = 0; i < document.window.length; i++) {
			if(document.window[i]['name'] == name) {
				return document.window[i];
			}
		}
	}
	MUI.openProject = function(a) {
		MUI.setProjectId(a);
		MUI.setFocusedObjectId(a);
		MUI.updateContent({
			element : $('mainPanel'),
			title : 'Project: ' + a,
			url : MUI.appPath + '/project_view.php?projectId=' + a,
		});

	};
	MUI.setPage = function(pp_projectId, pp_masterId, pp_pageId, pp_pageLang, pp_mapId, pp_projectName) {
		if(pp_pageId != MUI.pageId) {
			MUI.updateInterfaces(pp_pageId, 'loadNewPage');
		}
		MUI.setMasterId(pp_masterId);
		MUI.setMapId(pp_mapId);
		MUI.setPageId(pp_pageId);
		MUI.setPageLang(pp_pageLang);
		MUI.setProjectId(pp_projectId);
		MUI.setProjectName(pp_projectName);
	};
	MUI.updateInterfaces = function(focusedObject, fType) {
		MUI.setFocusedObjectId(focusedObject);
		if(fType == 'loadNewPage') {
			if(MUI.appState == 'editContent') {
				MUI.updateContent({
					'element' : $('treeView'),
					'url' : $$('li.selected a')
				});
			}
		}
		if(fType == 'editObjectText') {
			if(MUI.appState == 'editSitemap') {
				MUI.updateContent({
					'element' : $('treeView'),
					'url' : $$('li.selected a')
				});
			}
			MUI.mainContentFrame.location.reload(true);
		}
		if(fType == 'saveAttributeList') {
			MUI.mainContentFrame.location.reload(true);
		}
		if(fType == 'deleteAttribute') {
			MUI.mainContentFrame.location.reload(true);
		}
		if(fType == 'deleteObject') {
			MUI.mainContentFrame.location.reload(true);
			if(MUI.appState != 'editAttributes') {
				MUI.updateContent({
					'element' : $('treeView'),
					'url' : $$('li.selected a')
				});
			}
			if(MUI.appState == 'editContent') {
				MUI.setFocusedObjectId(MUI.pageId);
			}
		}
		if(fType == 'createObject') {
			MUI.action = 'createObject';
			MUI.mainContentFrame.location.reload(true);
			MUI.updateContent({
				'element' : $('treeView'),
				'url' : $$('li.selected a')
			});
			MUI.doSomeInIframe(focusedObject);
		}
		if(fType == 'focus') {
			MUI.doSomeInIframe(focusedObject);
		}
		if(fType == 'reloadedTree') {
			MUI.setAppState($$('li.selected a').get('id'));
			state = MUI.appState;
			MUI.mainContentFrame.$$('div.objectHandle').addClass('hidden');

			if(MUI.action == 'createObject') {
				MUI.setAction('empty');
			} else {
				if(state == 'editCss') {
					MUI.setFocusedObjectId(MUI.projectId);
				}
				if(state == 'editSitemap') {
					MUI.setFocusedObjectId(MUI.mapId);
				}
				if(state == 'editMaster') {
					MUI.mainContentFrame.$$('div.objectHandle.master').toggleClass('hidden');
					MUI.setFocusedObjectId(MUI.masterId);
				}
				if(state == 'editContent') {
					MUI.mainContentFrame.$$('div.objectHandle.content').toggleClass('hidden');
					MUI.setFocusedObjectId(MUI.pageId);
				}
			}
			if(MUI.toggles['handles_hide'] == 1) {
				MUI.toggleHandlesVisuals(1, 'handles_hide');
			}
			if(MUI.toggles['handles_dom'] == 1) {
				MUI.toggleHandlesVisuals(1, 'handles_dom');
			}
			MUI.doSomeInIframe(MUI.focusedObjectId);
		}
		$$('.mif-tree-node-wrapper').removeClass('mif-tree-node-selected');
		if($(MUI.focusedObjectId)) {
			$(MUI.focusedObjectId).addClass('mif-tree-node-selected').id
		}
		MUI.doSomeInIframe(MUI.focusedObjectId);
		MUI.updateContent({// Update Ajax Form with Focused object Properties
			'element' : $('propertiesForm'),
			'url' : MUI.appPath + '/admin_data.php?props=yes&fid=' + focusedObject
		});
		MUI.updateContent({// Update Console with Focussed object TExt...
			'element' : $('textForm'),
			'url' : MUI.appPath + '/admin_data.php?text=yes&fid=' + focusedObject + '&lang=' + MUI.pageLang
		});
	};
	MUI.outputWindow();
}