/*
 *
 * In this file we initialize MochaUI. And all the ui's application-variables
 * 
 *
 */

// Initialize MochaUI when the DOM is ready
window.addEvent('load', function(){ // using load instead of DOM ready for IE8

	MUI.appState = new Object();
	MUI.elementFilter = new Object();
	MUI.masterId = new Object();
	MUI.projectId = new Object();
	MUI.pageId = new Object();
	MUI.pageLang = new Object();
	MUI.domain = new Object();
	MUI.appPath = new Object();
	MUI.appFileManagerPath = new Object();
	MUI.mapId = new Object();
	MUI.focusedObjectId = new Object();
	MUI.projectName = new Object();
	MUI.toggles = [];
	MUI.domain = PP_HOST;
	MUI.appFileManagerPath = PP_FILEMANAGER;
	MUI.appPath = PP_APP;
	MUI.appState = 'editMaster';
	MUI.action = 'initial';

	// Contextmenu for treeView
 	testMenu = new Mif.Menu({
		list: {
			items: [
			{
				name: 'delete element',
				id: 'deleteOption',
				value: 'haha',
				icon: 'mif-tree-delete-close-icon',
				onAction: function(){
					MUI.deleteObject(0);
				}
			},
		
			{
				name: 'rename element',
				id: 'renameOption',
				value: '20',
				icon: 'mif-tree-edit-close-icon',
				onAction: function(){
					var node = tree.selected;
				    if(!node) return;
				    node.rename();
				}
			},
	
			]
		}
	});
	// Contextmenu for filemananger
	filemanager_menu = new Mif.Menu({
		list: {
			items: [
			
			{
				name: 'rename',
				id: 'deleteOption',
				value: '',
				icon: 'mif-tree-rename-close-icon',
				onAction: function(){
					MUI.trace(this.options.value);
					
				    MUI.filemanagerModal('renameModal' ,'iframe', this.options.value, 1);
				
				}
			},
			{
				name: 'delete',
				id: 'takes_nodName',
				value: '',
				icon: 'mif-tree-delete-close-icon',
				onAction: function(){
					MUI.trace(this.options.value);
					MUI.filemanagerModal('deleteModal' ,'iframe', this.options.value, 1);
				
				}
			},
			{
				name: 'upload file',
				id: 'takes_nodName',
				value: '',
				icon: 'mif-tree-upload-open-icon',
				onAction: function(){
					MUI.trace(this.options.value);
					MUI.filemanagerModal('uploadModal' ,'iframe', this.options.value, 1);
				}
			},
			{
				name: 'new folder',
				value: '',
				icon: 'mif-tree-map-close-icon',
				onAction: function(){
					MUI.trace(this.options.value);
					MUI.filemanagerModal('newModal' ,'iframe', this.options.value, 1);
				}

			},
			{
				name: 'new file',
				value: '',
				icon: 'mif-tree-fileItem-open-icon',
				onAction: function(){
					MUI.trace(this.options.value);
					MUI.filemanagerModal('newModal' ,'iframe', this.options.value, 1);
				}

			},
			{
				name: 'edit',
				value: '',
				icon: 'mif-tree-edit-open-icon',
				onAction: function(){
					MUI.trace(this.options.value);
					MUI.codeEditor('editModal' ,'iframe', this.options.value, 1);
				}

			},
			{
				name: 'reload',
				id: 'reloadOption',
				value: 'haha',
				icon: 'mif-tree-refresh-open-icon',
				onAction: function(){
					var selected = fileTree.getSelected();
					if(!selected) return;
					selected.reloadChildren().toggle(true);
				}
			},
			]
		}
	});
	
	MUI.myChain = new Chain();
	
	MUI.myChain.chain(
	function(){MUI.Desktop.initialize();},
	function(){MUI.Dock.initialize();},
	function(){initializeColumns();},
	function(){initializeWindows();}
	).callChain();
	
	MUI.dbCheck = new Request({
		method : 'post',
		url : MUI.appPath + '/admin_data.php',
		data : 'action=checkDB',
		onComplete : function(response) {
			if(response==0){
				//MUI.notification('db-seems to be set up correctly');
			}else{
				MUI.notification('problem with db settings !');
				MUI.trace(response)
				MUI.dbSettings();
			}
			
		}
	}).send();
	
});

