/*
 *
 * My MUI.Windows
 * 
 *
 */

var initializeWindows = function() {
	MUI.createprojectWindow = function() {
		new MUI.Window({
			id : 'createproject',
			title : 'Create a new Project',
			loadMethod : 'xhr',
			height : 145,
			width : 300,
			resizable : false,
			maximizable : false,
			minimizable : false,
			padding : {
				top : 12,
				right : 12,
				bottom : 10,
				left : 12
			},
			contentURL : 'pages/create_project_form.html',
			onContentLoaded : function() {
				$('testForm').addEvent('submit', function(e) {
					e.stop();
					this.set('send', {
						method : 'post',
						url : MUI.appPath + '/admin_data.php', // ORIGINAL APP
						onComplete : function(response) {
							//MUI.trace(response);
							MochaUI.closeWindow($('createproject'));
						},
					});
					this.send();
				});
			}
		});
	};
	if($('createprojectWindow')) {
		$('createprojectWindow').addEvent('click', function(e) {
			new Event(e).stop();
			MUI.createprojectWindow();
		});
	}
	MUI.openprojectWindow = function() {
		new MUI.Window({
			id : 'projects',
			title : 'projects',
			height : 450,
			width : 400,
			loadMethod : 'xhr',
			contentURL : MUI.appPath + '/admin_data.php?allProjects=1',
			onContentLoaded : function(b) {
				var frame = MUI.getFrameByName('projects_iframe');
				$('projectId').addEvent('change', function(e) {
					MUI.setFocusedObjectId(this.value);
				});
				$('open_btn').addEvent('click', function(e) {
					e.stop();
					MUI.closeWindow($('projects'));
					MUI.openProject(MUI.focusedObjectId);
				});
				$('delete_btn').addEvent('click', function(e) {
					e.stop();
					if(confirm("Really delete projects entry " + MUI.focusedObjectId + " ?")) {
						MUI.deleteProject(MUI.focusedObjectId);
					}
				});
			}
		});
	};
	if($('openprojectLinkCheck')) {
		$('openprojectLinkCheck').addEvent('click', function(e) {
			new Event(e).stop();
			MUI.openprojectWindow();
		});
	}
	MUI.fileManagerWindow = function() {
		new MUI.Window({
			id : 'fileManager',
			title : 'file manager',
			closable : 1,
			resizable : false,
			require : {
				css : [MUI.path.plugins + 'fileManager/css/loader_css.css'],
			},
			width : 600,
			height : 360,
			x : 600,
			y : 100,
			onContentLoaded : function() {
				new MUI.Column({
					container : 'fileManager_contentWrapper',
					id : 'fileManager_sideColumn',
					placement : 'left',
					width : 600,
					resizeLimit : [600, 600] // These size settings hide the preview column
				});
				new MUI.Column({
					container : 'fileManager_contentWrapper',
					id : 'fileManager_mainColumn',
					placement : 'main',
					width : null,
					resizeLimit : [100, 300]
				});
				new MUI.Panel({
					header : false,
					id : 'splitWindow_panel1',
					contentURL : 'pages/file_manager_preview.html',
					column : 'fileManager_mainColumn',
					panelBackground : '#fff'
				});
				new MUI.Panel({
					header : false,
					id : 'splitWindow_panel2',
					addClass : 'panelAlt',
					contentURL : 'pages/mif-tree-files.html',
					column : 'fileManager_sideColumn'
				});
			}
		});
	};
	if($('openFileManager')) {
		$('openFileManager').addEvent('click', function(e) {
			new Event(e).stop();
			MUI.fileManagerWindow();
		});
	}
	MUI.filemanagerModal = function(id, loadmethod, path, init) {
		new MUI.Modal({
			id : id,
			title : 'File Manager Dialog',
			loadMethod : loadmethod,
			contentURL : MUI.domain + path,
			width : 350,
			height : 250,
			onContentLoaded : function(response) {
				if(init != 1) {
					var selected = parent.fileTree.getSelected();
					if(!selected)
						return;
					if(this.options.id == 'newModal') {
						selected.reloadChildren().toggle(true);
					}
					if(this.options.id == 'uploadModal') {
						selected.reloadChildren().toggle(true);
					}
					if(this.options.id == 'renameModal') {
						selected.parentNode.reloadChildren().toggle(true);
					}
					if(this.options.id == 'deleteModal') {
						selected.parentNode.reloadChildren().toggle(true);
					}
					MUI.closeWindow($(this.options.id));
				}
				init = 0;
			}
		});
	}
	MUI.codeEditor = function(id, loadmethod, path, init) {
		new MUI.Window({
			id : 'codeEditor',
			title : 'Code Editor',
			width : 984,
			height : 690,
			resizable : false,
			loadMethod : 'iframe',
			contentURL : MUI.domain + path,
			onContentLoaded : function() {
				
			
			}
		});
	}
	MUI.dbSettings = function() {
		new MUI.Window({
			id : 'dbSettings_window',
			title : 'Database Settings',
			width : 360,
			height : 422,
			resizable : false,
			loadMethod : 'xhr',
			contentURL : 'pages/db_settings.php',
			onContentLoaded : function() {
				$('myForm').addEvent('submit', function(e) {
					e.stop();
					this.set('send', {
						method : 'post',
						url : MUI.appPath + '/admin_data.php',
						onComplete : function(response) {
							$('responseDiv').set('html', response);
						},
					});
					this.send();
				});
			}
		});
	}
	if($('dbSettings')) {
		$('dbSettings').addEvent('click', function(e) {
			new Event(e).stop();
			MUI.dbSettings();
		});
	}
	MUI.outputWindow = function() {
		new MUI.Window({
			id : 'mochaConsole',
			addClass : 'mochaConsole',
			title : 'Output',
			closable : 1,
			width : 600,
			height : 400,
			x : 800,
			y : 100
		});
	}
	if($('openTraceWindow')) {
		$('openTraceWindow').addEvent('click', function(e) {
			new Event(e).stop();
			MUI.outputWindow();
		});
	}
	//MUI.outputWindow();
};
